<template>
    <custom-table :data="state.userList" :headers="state.headers" :pageSize="state.pageSize" :pageDisplayCount="4"
        :showButtonName="state.showButtonName" :showButton="true"/>
</template>
<script>
import { reactive, onMounted } from 'vue';
import CustomTable from '@/components/custom-controller/CustomTable.vue';
import UserService from "@/services/UserService";
import { setEncryptedList, getDecryptedList } from "@/utils/customEncryptionAndDecryption"
import { UserMap } from "@/models/UserModel"
import eventBus from '@/plugins/eventBus';
export default {
    name: "UserList",
    components: {
        CustomTable
    },
    setup() {
        const state = reactive({
            isOpenExpiressionPanel: true,
            panel: [0, 1],
            readonly: false,
            userList: [],
            headers: ['Id', 'Username', 'Name', 'Surname', 'IsActive', ''],
            pageSize: 5,
            showButtonName:"Yetki Ekle"

        });

        const getAllUser = () => {
            const userListCache = getDecryptedList("userList")
            if (userListCache) {
                state.userList=UserMap(userListCache)
                
                console.log("data :", state.userList);
            } else {
                console.log("girdi");
                UserService.GetAllUser()
                    .then(response => {
                        const userList = response.data.Response;
                        setEncryptedList(userList, "userList")
                        state.userList=UserMap(userListCache)
                    })
                    .catch(error => {
                        console.log(error);
                    });
            }
        };

        onMounted(() => {
            getAllUser();
            eventBus.off('table-btn');
            eventBus.on('table-btn', function (event) {
                console.log("ok : ", event);
            });
        });

        return {
            state,
        };
    }
}
</script>
<style scoped>
@import "@/assets/styles/custom/custom-input.css";

</style>